Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34921)
@@ -24,4 +24,8 @@
 #               9) http://www.w3.org/TR/SVG11/
 #               10) http://www.adobe.com/devnet/xmp/pdfs/XMPSpecificationPart2.pdf (Oct 2008)
+#               11) http://www.extensis.com/en/support/kb_article.jsp?articleNumber=6102211
+#               12) http://www.cipa.jp/std/documents/e/DC-010-2012_E.pdf
+#               13) http://www.cipa.jp/std/documents/e/DC-010-2017_E.pdf (changed to
+#                   http://www.cipa.jp/std/documents/e/DC-X010-2017.pdf)
 #
 # Notes:      - Property qualifiers are handled as if they were separate
@@ -40,11 +44,12 @@
 
 use strict;
-use vars qw($VERSION $AUTOLOAD @ISA @EXPORT_OK $xlatNamespace %nsURI %dateTimeInfo
-            %xmpTableDefaults %specialStruct %sDimensions %sArea %sColorant);
+use vars qw($VERSION $AUTOLOAD @ISA @EXPORT_OK %stdXlatNS %nsURI %latConv %longConv
+            %dateTimeInfo %xmpTableDefaults %specialStruct %sDimensions %sArea %sColorant);
 use Image::ExifTool qw(:Utils);
 use Image::ExifTool::Exif;
+use Image::ExifTool::GPS;
 require Exporter;
 
-$VERSION = '2.37';
+$VERSION = '3.38';
 @ISA = qw(Exporter);
 @EXPORT_OK = qw(EscapeXML UnescapeXML);
@@ -52,20 +57,21 @@
 sub ProcessXMP($$;$);
 sub WriteXMP($$;$);
-sub CheckXMP($$$);
-sub ParseXMPElement($$$;$$$);
+sub CheckXMP($$$;$);
+sub ParseXMPElement($$$;$$$$);
 sub DecodeBase64($);
+sub EncodeBase64($;$);
 sub SaveBlankInfo($$$;$);
 sub ProcessBlankInfo($$$;$);
 sub ValidateXMP($;$);
-sub UnescapeChar($$);
-sub AddFlattenedTags($$);
+sub ValidateProperty($$;$);
+sub UnescapeChar($$;$);
+sub AddFlattenedTags($;$$);
 sub FormatXMPDate($);
 sub ConvertRational($);
-
-my %curNS;  # namespaces currently in effect while parsing the file
-
-# lookup for translating to ExifTool namespaces
-# Note: Use $xlatNamespace (only valid during processing) to do the translation
-my %stdXlatNS = (
+sub ConvertRationalList($);
+sub WriteGSpherical($$$);
+
+# lookup for translating to ExifTool namespaces (and family 1 group names)
+%stdXlatNS = (
     # shorten ugly namespace prefixes
     'Iptc4xmpCore' => 'iptcCore',
@@ -74,28 +80,33 @@
     'MicrosoftPhoto' => 'microsoft',
     'prismusagerights' => 'pur',
-);
-
-# translate ExifTool namespaces to standard XMP namespace prefixes
+    'GettyImagesGIFT' => 'getty',
+);
+
+# translate ExifTool XMP family 1 group names back to standard XMP namespace prefixes
 my %xmpNS = (
-    # shorten ugly namespace prefixes
     'iptcCore' => 'Iptc4xmpCore',
     'iptcExt' => 'Iptc4xmpExt',
-    'photomechanic'=> 'photomech',
+    'photomech'=> 'photomechanic',
     'microsoft' => 'MicrosoftPhoto',
+    'getty' => 'GettyImagesGIFT',
     # (prism changed their spec to now use 'pur')
     # 'pur' => 'prismusagerights',
 );
 
-# Lookup to translate our namespace prefixes into URI's.  This list need
-# not be complete, but it must contain an entry for each namespace prefix
-# (NAMESPACE) for writable tags in the XMP tables or in structures
+# Lookup to translate standard XMP namespace prefixes into URI's.  This list
+# need not be complete, but it must contain an entry for each namespace prefix
+# (NAMESPACE) for writable tags in the XMP tables or in structures that doesn't
+# define a URI.  Also, the namespace must be defined here for non-standard
+# namespace prefixes to be recognized.
 %nsURI = (
     aux       => 'http://ns.adobe.com/exif/1.0/aux/',
     album     => 'http://ns.adobe.com/album/1.0/',
     cc        => 'http://creativecommons.org/ns#', # changed 2007/12/21 - PH
+    crd       => 'http://ns.adobe.com/camera-raw-defaults/1.0/',
     crs       => 'http://ns.adobe.com/camera-raw-settings/1.0/',
     crss      => 'http://ns.adobe.com/camera-raw-saved-settings/1.0/',
     dc        => 'http://purl.org/dc/elements/1.1/',
     exif      => 'http://ns.adobe.com/exif/1.0/',
+    exifEX    => 'http://cipa.jp/exif/1.0/',
     iX        => 'http://ns.adobe.com/iX/1.0/',
     pdf       => 'http://ns.adobe.com/pdf/1.3/',
@@ -105,5 +116,4 @@
     rdfs      => 'http://www.w3.org/2000/01/rdf-schema#',
     stDim     => 'http://ns.adobe.com/xap/1.0/sType/Dimensions#',
-    stArea    => 'http://ns.adobe.com/xap/1.0/sType/Area#',
     stEvt     => 'http://ns.adobe.com/xap/1.0/sType/ResourceEvent#',
     stFnt     => 'http://ns.adobe.com/xap/1.0/sType/Font#',
@@ -127,4 +137,5 @@
     dex       => 'http://ns.optimasc.com/dex/1.0/',
     mediapro  => 'http://ns.iview-multimedia.com/mediapro/1.0/',
+    expressionmedia => 'http://ns.microsoft.com/expressionmedia/1.0/',
     Iptc4xmpCore => 'http://iptc.org/std/Iptc4xmpCore/1.0/xmlns/',
     Iptc4xmpExt => 'http://iptc.org/std/Iptc4xmpExt/2008-02-29/',
@@ -136,22 +147,47 @@
     lr        => 'http://ns.adobe.com/lightroom/1.0/',
     DICOM     => 'http://ns.adobe.com/DICOM/',
+   'drone-dji'=> 'http://www.dji.com/drone-dji/1.0/',
     svg       => 'http://www.w3.org/2000/svg',
     et        => 'http://ns.exiftool.ca/1.0/',
-    # namespaces defined in XMP2.pl:
+#
+# namespaces defined in XMP2.pl:
+#
     plus      => 'http://ns.useplus.org/ldf/xmp/1.0/',
-    prism     => 'http://prismstandard.org/namespaces/basic/2.1/',
+    # (prism recommendations from http://www.prismstandard.org/specifications/3.0/Image_Guide_3.0.htm)
+    prism     => 'http://prismstandard.org/namespaces/basic/2.0/',
     prl       => 'http://prismstandard.org/namespaces/prl/2.1/',
     pur       => 'http://prismstandard.org/namespaces/prismusagerights/2.1/',
+    pmi       => 'http://prismstandard.org/namespaces/pmi/2.2/',
+    prm       => 'http://prismstandard.org/namespaces/prm/3.0/',
     acdsee    => 'http://ns.acdsee.com/iptc/1.0/',
     digiKam   => 'http://www.digikam.org/ns/1.0/',
-    swf       => 'http://ns.adobe.com/swf/1.0',
+    swf       => 'http://ns.adobe.com/swf/1.0/',
     cell      => 'http://developer.sonyericsson.com/cell/1.0/',
+    aas       => 'http://ns.apple.com/adjustment-settings/1.0/',
    'mwg-rs'   => 'http://www.metadataworkinggroup.com/schemas/regions/',
    'mwg-kw'   => 'http://www.metadataworkinggroup.com/schemas/keywords/',
    'mwg-coll' => 'http://www.metadataworkinggroup.com/schemas/collections/',
+    stArea    => 'http://ns.adobe.com/xmp/sType/Area#',
+    extensis  => 'http://ns.extensis.com/extensis/1.0/',
+    ics       => 'http://ns.idimager.com/ics/1.0/',
+    fpv       => 'http://ns.fastpictureviewer.com/fpv/1.0/',
+    creatorAtom=>'http://ns.adobe.com/creatorAtom/1.0/',
+   'apple-fi' => 'http://ns.apple.com/faceinfo/1.0/',
+    GAudio    => 'http://ns.google.com/photos/1.0/audio/',
+    GImage    => 'http://ns.google.com/photos/1.0/image/',
+    GPano     => 'http://ns.google.com/photos/1.0/panorama/',
+    GSpherical=> 'http://ns.google.com/videos/1.0/spherical/',
+    GDepth    => 'http://ns.google.com/photos/1.0/depthmap/',
+    GFocus    => 'http://ns.google.com/photos/1.0/focus/',
+    GCamera   => 'http://ns.google.com/photos/1.0/camera/',
+    GCreations=> 'http://ns.google.com/photos/1.0/creations/',
+    dwc       => 'http://rs.tdwg.org/dwc/index.htm',
+    GettyImagesGIFT => 'http://xmp.gettyimages.com/gift/1.0/',
+    LImage    => 'http://ns.leiainc.com/photos/1.0/image/',
+    Profile   => 'http://ns.google.com/photos/dd/1.0/profile/',
 );
 
 # build reverse namespace lookup
-my %uri2ns;
+my %uri2ns = ( 'http://ns.exiftool.org/1.0/' => 'et' ); # (allow exiftool.org as well as exiftool.ca)
 {
     my $ns;
@@ -162,28 +198,15 @@
 
 # conversions for GPS coordinates
-sub ToDegrees
-{
-    require Image::ExifTool::GPS;
-    Image::ExifTool::GPS::ToDegrees($_[0], 1);
-}
-my %latConv = (
-    ValueConv    => \&ToDegrees,
-    RawConv => 'require Image::ExifTool::GPS; $val', # to load Composite tags and routines
-    ValueConvInv => q{
-        require Image::ExifTool::GPS;
-        Image::ExifTool::GPS::ToDMS($self, $val, 2, "N");
-    },
+%latConv = (
+    ValueConv    => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
+    ValueConvInv => 'Image::ExifTool::GPS::ToDMS($self, $val, 2, "N")',
     PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "N")',
-    PrintConvInv => \&ToDegrees,
-);
-my %longConv = (
-    ValueConv    => \&ToDegrees,
-    RawConv => 'require Image::ExifTool::GPS; $val',
-    ValueConvInv => q{
-        require Image::ExifTool::GPS;
-        Image::ExifTool::GPS::ToDMS($self, $val, 2, "E");
-    },
+    PrintConvInv => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
+);
+%longConv = (
+    ValueConv    => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
+    ValueConvInv => 'Image::ExifTool::GPS::ToDMS($self, $val, 2, "E")',
     PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1, "E")',
-    PrintConvInv => \&ToDegrees,
+    PrintConvInv => 'Image::ExifTool::GPS::ToDegrees($val, 1)',
 );
 %dateTimeInfo = (
@@ -191,6 +214,21 @@
     Writable => 'date',
     Shift => 'Time',
+    Validate => 'ValidateXMPDate($val)',
     PrintConv => '$self->ConvertDateTime($val)',
     PrintConvInv => '$self->InverseDateTime($val,undef,1)',
+);
+
+# this conversion allows alternate language support for designated boolean tags
+my %boolConv = (
+    PrintConv => {
+        OTHER => sub { # (inverse conversion is the same)
+            my $val = shift;
+            return 'False' if lc $val eq 'false';
+            return 'True' if lc $val eq 'true';
+            return $val;
+        },
+        True => 'True',
+        False => 'False',
+    },
 );
 
@@ -198,4 +236,7 @@
 # (Note: namespaces with non-standard prefixes aren't currently ignored)
 my %ignoreNamespace = ( 'x'=>1, rdf=>1, xmlns=>1, xml=>1, svg=>1, et=>1, office=>1 );
+
+# XMP properties to ignore (set dynamically via dirInfo IgnoreProp)
+my %ignoreProp;
 
 # these are the attributes that we handle for properties that contain
@@ -211,5 +252,6 @@
     'rdf:nodeID' => 1,
     'et:toolkit' => 1,
-    'rdf:xmlns' => 1, # this is presumably the default namespace, which we currently ignore
+    'rdf:xmlns'  => 1, # this is presumably the default namespace, which we currently ignore
+    'lastUpdate' => [ 'Image::ExifTool::XMP::XML', 'lastUpdate', 'LastUpdate' ], # found in XML from Sony ILCE-7S MP4
 );
 
@@ -222,4 +264,5 @@
     TYPE        => 1, # [optional] rdf:type resource for struct (if used, the StructType flag
                       # will be set automatically for all derived flattened tags when writing)
+    GROUPS      => 1, # [optional] specifies family group 2 name for the structure
 );
 # XMP structures (each structure is similar to a tag table so we can
@@ -252,4 +295,11 @@
     # added May 2010
     originalDocumentID => { }, # (undocumented property written by Adobe InDesign)
+    # added Aug 2016 (INDD again)
+    lastURL         => { },
+    linkForm        => { },
+    linkCategory    => { },
+    placedXResolution    => { },
+    placedYResolution    => { },
+    placedResolutionUnit => { },
 );
 my %sResourceEvent = (
@@ -287,4 +337,6 @@
    'format'     => { },
     image       => {
+        Avoid => 1,
+        Groups => { 2 => 'Preview' },
         ValueConv => 'Image::ExifTool::XMP::DecodeBase64($val)',
         ValueConvInv => 'Image::ExifTool::XMP::EncodeBase64($val)',
@@ -299,4 +351,5 @@
    'format'     => { },
     image       => {
+        Groups => { 2 => 'Preview' },
         ValueConv => 'Image::ExifTool::XMP::DecodeBase64($val)',
         ValueConvInv => 'Image::ExifTool::XMP::EncodeBase64($val)',
@@ -339,7 +392,21 @@
     green       => { Writable => 'integer' },
     blue        => { Writable => 'integer' },
+    gray        => { Writable => 'integer' },
     L           => { Writable => 'real' },
     A           => { Writable => 'integer' },
     B           => { Writable => 'integer' },
+    # 'tint' observed in INDD sample - PH
+    tint        => { Writable => 'integer', Notes => 'not part of 2010 XMP specification' },
+);
+my %sSwatchGroup = (
+    STRUCT_NAME => 'SwatchGroup',
+    NAMESPACE   => 'xmpG',
+    groupName   => { },
+    groupType   => { Writable => 'integer' },
+    Colorants => {
+        FlatName => 'SwatchColorant',
+        Struct => \%sColorant,
+        List => 'Seq',
+    },
 );
 my %sFont = (
@@ -356,6 +423,6 @@
 );
 my %sOECF = (
+    STRUCT_NAME => 'OECF',
     NAMESPACE   => 'exif',
-    STRUCT_NAME => 'OECF',
     Columns     => { Writable => 'integer' },
     Rows        => { Writable => 'integer' },
@@ -368,42 +435,105 @@
     STRUCT_NAME => 'CorrectionMask',
     NAMESPACE   => 'crs',
-    What         => { },
-    MaskValue    => { Writable => 'real' },
-    Radius       => { Writable => 'real' },
-    Flow         => { Writable => 'real' },
-    CenterWeight => { Writable => 'real' },
+    # disable List behaviour of flattened Gradient/PaintBasedCorrections
+    # because these are nested in lists and the flattened tags can't
+    # do justice to this complex structure
+    What         => { List => 0 },
+    MaskValue    => { Writable => 'real', List => 0, FlatName => 'Value' },
+    Radius       => { Writable => 'real', List => 0 },
+    Flow         => { Writable => 'real', List => 0 },
+    CenterWeight => { Writable => 'real', List => 0 },
     Dabs         => { List => 'Seq' },
-    ZeroX        => { Writable => 'real' },
-    ZeroY        => { Writable => 'real' },
-    FullX        => { Writable => 'real' },
-    FullY        => { Writable => 'real' },
+    ZeroX        => { Writable => 'real', List => 0 },
+    ZeroY        => { Writable => 'real', List => 0 },
+    FullX        => { Writable => 'real', List => 0 },
+    FullY        => { Writable => 'real', List => 0 },
+    # new elements used in CircularGradientBasedCorrections CorrectionMasks
+    # and RetouchAreas Masks
+    Top          => { Writable => 'real', List => 0 },
+    Left         => { Writable => 'real', List => 0 },
+    Bottom       => { Writable => 'real', List => 0 },
+    Right        => { Writable => 'real', List => 0 },
+    Angle        => { Writable => 'real', List => 0 },
+    Midpoint     => { Writable => 'real', List => 0 },
+    Roundness    => { Writable => 'real', List => 0 },
+    Feather      => { Writable => 'real', List => 0 },
+    Flipped      => { Writable => 'boolean', List => 0 },
+    Version      => { Writable => 'integer', List => 0 },
+    SizeX        => { Writable => 'real', List => 0 },
+    SizeY        => { Writable => 'real', List => 0 },
+    X            => { Writable => 'real', List => 0 },
+    Y            => { Writable => 'real', List => 0 },
+    Alpha        => { Writable => 'real', List => 0 },
+    CenterValue  => { Writable => 'real', List => 0 },
+    PerimeterValue=>{ Writable => 'real', List => 0 },
+);
+my %sCorrectionRangeMask = (
+    STRUCT_NAME => 'CorrectionRangeMask',
+    NAMESPACE   => 'crs',
+    Version     => { },
+    Type        => { },
+    ColorAmount => { Writable => 'real' },
+    LumMin      => { Writable => 'real' },
+    LumMax      => { Writable => 'real' },
+    LumFeather  => { Writable => 'real' },
+    DepthMin    => { Writable => 'real' },
+    DepthMax    => { Writable => 'real' },
+    DepthFeather=> { Writable => 'real' },
 );
 my %sCorrection = (
     STRUCT_NAME => 'Correction',
     NAMESPACE   => 'crs',
-    What => { },
-    CorrectionAmount => { Writable => 'real' },
-    CorrectionActive => { Writable => 'boolean' },
-    LocalExposure    => { Writable => 'real' },
-    LocalSaturation  => { Writable => 'real' },
-    LocalContrast    => { Writable => 'real' },
-    LocalClarity     => { Writable => 'real' },
-    LocalSharpness   => { Writable => 'real' },
-    LocalBrightness  => { Writable => 'real' },
-    LocalToningHue   => { Writable => 'real' },
-    LocalToningSaturation => { Writable => 'real' },
-    CorrectionMasks  => { Struct => \%sCorrectionMask, List => 'Seq' },
-);
-
-# IPTC Extension 1.0 structures
-my %sLocationDetails = (
-    NAMESPACE   => 'Iptc4xmpExt',
-    STRUCT_NAME => 'LocationDetails',
-    City         => { },
-    CountryCode  => { },
-    CountryName  => { },
-    ProvinceState=> { },
-    Sublocation  => { },
-    WorldRegion  => { },
+    What => { List => 0 },
+    CorrectionAmount => { FlatName => 'Amount',     Writable => 'real', List => 0 },
+    CorrectionActive => { FlatName => 'Active',     Writable => 'boolean', List => 0 },
+    LocalExposure    => { FlatName => 'Exposure',   Writable => 'real', List => 0 },
+    LocalSaturation  => { FlatName => 'Saturation', Writable => 'real', List => 0 },
+    LocalContrast    => { FlatName => 'Contrast',   Writable => 'real', List => 0 },
+    LocalClarity     => { FlatName => 'Clarity',    Writable => 'real', List => 0 },
+    LocalSharpness   => { FlatName => 'Sharpness',  Writable => 'real', List => 0 },
+    LocalBrightness  => { FlatName => 'Brightness', Writable => 'real', List => 0 },
+    LocalToningHue   => { FlatName => 'Hue',        Writable => 'real', List => 0 },
+    LocalToningSaturation => { FlatName => 'Saturation',        Writable => 'real', List => 0 },
+    LocalExposure2012     => { FlatName => 'Exposure2012',      Writable => 'real', List => 0 },
+    LocalContrast2012     => { FlatName => 'Contrast2012',      Writable => 'real', List => 0 },
+    LocalHighlights2012   => { FlatName => 'Highlights2012',    Writable => 'real', List => 0 },
+    LocalShadows2012      => { FlatName => 'Shadows2012',       Writable => 'real', List => 0 },
+    LocalClarity2012      => { FlatName => 'Clarity2012',       Writable => 'real', List => 0 },
+    LocalLuminanceNoise   => { FlatName => 'LuminanceNoise',    Writable => 'real', List => 0 },
+    LocalMoire       => { FlatName => 'Moire',      Writable => 'real', List => 0 },
+    LocalDefringe    => { FlatName => 'Defringe',   Writable => 'real', List => 0 },
+    LocalTemperature => { FlatName => 'Temperature',Writable => 'real', List => 0 },
+    LocalTint        => { FlatName => 'Tint',       Writable => 'real', List => 0 },
+    LocalHue         => { FlatName => 'Hue',        Writable => 'real', List => 0 },
+    LocalWhites2012  => { FlatName => 'Whites2012', Writable => 'real', List => 0 },
+    LocalBlacks2012  => { FlatName => 'Blacks2012', Writable => 'real', List => 0 },
+    LocalDehaze      => { FlatName => 'Dehaze', Writable => 'real', List => 0 },
+    LocalTexture     => { FlatName => 'Texture', Writable => 'real', List => 0 },
+    CorrectionRangeMask => {
+        FlatName => 'RangeMask',
+        Struct => \%sCorrectionRangeMask,
+    },
+    CorrectionMasks  => {
+        FlatName => 'Mask',
+        Struct => \%sCorrectionMask,
+        List => 'Seq',
+    },
+);
+my %sRetouchArea = (
+    STRUCT_NAME => 'RetouchArea',
+    NAMESPACE   => 'crs',
+    SpotType        => { List => 0 },
+    SourceState     => { List => 0 },
+    Method          => { List => 0 },
+    SourceX         => { Writable => 'real',    List => 0 },
+    OffsetY         => { Writable => 'real',    List => 0 },
+    Opacity         => { Writable => 'real',    List => 0 },
+    Feather         => { Writable => 'real',    List => 0 },
+    Seed            => { Writable => 'integer', List => 0 },
+    Masks => {
+        FlatName => 'Mask',
+        Struct => \%sCorrectionMask,
+        List => 'Seq',
+    },
 );
 
@@ -457,9 +587,13 @@
         SubDirectory => { TagTable => 'Image::ExifTool::XMP::photoshop' },
     },
+    crd => {
+        Name => 'crd',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::crd' },
+    },
     crs => {
         Name => 'crs',
         SubDirectory => { TagTable => 'Image::ExifTool::XMP::crs' },
     },
-    # crss - it would be difficult to add the ability to write this
+    # crss - it would be tedious to add the ability to write this
     aux => {
         Name => 'aux',
@@ -474,4 +608,8 @@
         SubDirectory => { TagTable => 'Image::ExifTool::XMP::exif' },
     },
+    exifEX => {
+        Name => 'exifEX',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::exifEX' },
+    },
     iptcCore => {
         Name => 'iptcCore',
@@ -491,5 +629,5 @@
     plus => {
         Name => 'plus',
-        SubDirectory => { TagTable => 'Image::ExifTool::XMP::plus' },
+        SubDirectory => { TagTable => 'Image::ExifTool::PLUS::XMP' },
     },
     cc => {
@@ -509,4 +647,8 @@
         SubDirectory => { TagTable => 'Image::ExifTool::XMP::MediaPro' },
     },
+    expressionmedia => {
+        Name => 'expressionmedia',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::ExpressionMedia' },
+    },
     microsoft => {
         Name => 'microsoft',
@@ -545,4 +687,12 @@
         SubDirectory => { TagTable => 'Image::ExifTool::XMP::pur' },
     },
+    pmi => {
+        Name => 'pmi',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::pmi' },
+    },
+    prm => {
+        Name => 'prm',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::prm' },
+    },
     rdf => {
         Name => 'rdf',
@@ -569,20 +719,111 @@
         SubDirectory => { TagTable => 'Image::ExifTool::XMP::cell' },
     },
+    aas => {
+        Name => 'aas',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::aas' },
+    },
    'mwg-rs' => {
         Name => 'mwg-rs',
-        SubDirectory => { TagTable => 'Image::ExifTool::XMP::mwg_rs' },
+        SubDirectory => { TagTable => 'Image::ExifTool::MWG::Regions' },
     },
    'mwg-kw' => {
         Name => 'mwg-kw',
-        SubDirectory => { TagTable => 'Image::ExifTool::XMP::mwg_kw' },
+        SubDirectory => { TagTable => 'Image::ExifTool::MWG::Keywords' },
     },
    'mwg-coll' => {
         Name => 'mwg-coll',
-        SubDirectory => { TagTable => 'Image::ExifTool::XMP::mwg_coll' },
+        SubDirectory => { TagTable => 'Image::ExifTool::MWG::Collections' },
+    },
+    extensis => {
+        Name => 'extensis',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::extensis' },
+    },
+    ics => {
+        Name => 'ics',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::ics' },
+    },
+    fpv => {
+        Name => 'fpv',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::fpv' },
+    },
+    creatorAtom => {
+        Name => 'creatorAtom',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::creatorAtom' },
+    },
+   'apple-fi' => {
+        Name => 'apple-fi',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::apple_fi' },
+    },
+    GAudio => {
+        Name => 'GAudio',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GAudio' },
+    },
+    GImage => {
+        Name => 'GImage',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GImage' },
+    },
+    GPano => {
+        Name => 'GPano',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GPano' },
+    },
+    GSpherical => {
+        Name => 'GSpherical',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GSpherical' },
+    },
+    GDepth => {
+        Name => 'GDepth',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GDepth' },
+    },
+    GFocus => {
+        Name => 'GFocus',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GFocus' },
+    },
+    GCamera => {
+        Name => 'GCamera',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GCamera' },
+    },
+    GCreations => {
+        Name => 'GCreations',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GCreations' },
+    },
+    dwc => {
+        Name => 'dwc',
+        SubDirectory => { TagTable => 'Image::ExifTool::DarwinCore::Main' },
+    },
+    getty => {
+        Name => 'getty',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::GettyImages' },
+    },
+   'drone-dji' => {
+        Name => 'drone-dji',
+        SubDirectory => { TagTable => 'Image::ExifTool::DJI::XMP' },
+    },
+    LImage => {
+        Name => 'LImage',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::LImage' },
+    },
+    Device => {
+        Name => 'Device',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::Device' },
+    },
+);
+
+# hack to allow XML containing Dublin Core metadata to be handled like XMP (eg. EPUB - see ZIP.pm)
+%Image::ExifTool::XMP::XML = (
+    GROUPS => { 0 => 'XML', 1 => 'XML', 2 => 'Unknown' },
+    PROCESS_PROC => \&ProcessXMP,
+    dc => {
+        Name => 'dc',
+        SubDirectory => { TagTable => 'Image::ExifTool::XMP::dc' },
+    },
+    lastUpdate => {
+        Groups => { 2 => 'Time' },
+        ValueConv => 'Image::ExifTool::XMP::ConvertXMPDate($val)',
+        PrintConv => '$self->ConvertDateTime($val)',
     },
 );
 
 #
-# Tag tables for all XMP schemas:
+# Tag tables for all XMP namespaces:
 #
 # Writable - only need to define this for writable tags if not plain text
@@ -621,5 +862,5 @@
         The "x" namespace is used for the "xmpmeta" wrapper, and may contain an
         "xmptk" attribute that is extracted as the XMPToolkit tag.  When writing,
-        the XMPToolkit tag is automatically generated by ExifTool unless
+        the XMPToolkit tag is generated automatically by ExifTool unless
         specifically set to another value.
     },
@@ -627,5 +868,5 @@
 );
 
-# Dublin Core schema properties (dc)
+# Dublin Core namespace properties (dc)
 %Image::ExifTool::XMP::dc = (
     %xmpTableDefaults,
@@ -633,5 +874,5 @@
     NAMESPACE   => 'dc',
     TABLE_DESC => 'XMP Dublin Core',
-    NOTES => 'Dublin Core schema tags.',
+    NOTES => 'Dublin Core namespace tags.',
     contributor => { Groups => { 2 => 'Author' }, List => 'Bag' },
     coverage    => { },
@@ -651,5 +892,5 @@
 );
 
-# XMP Basic schema properties (xmp, xap)
+# XMP namespace properties (xmp, xap)
 %Image::ExifTool::XMP::xmp = (
     %xmpTableDefaults,
@@ -657,9 +898,9 @@
     NAMESPACE   => 'xmp',
     NOTES => q{
-        XMP Basic schema tags.  If the older "xap", "xapBJ", "xapMM" or "xapRights"
+        XMP namespace tags.  If the older "xap", "xapBJ", "xapMM" or "xapRights"
         namespace prefixes are found, they are translated to the newer "xmp",
         "xmpBJ", "xmpMM" and "xmpRights" prefixes for use in family 1 group names.
     },
-    Advisory    => { List => 'Bag' }, # (deprecated)
+    Advisory    => { List => 'Bag', Notes => 'deprecated' },
     BaseURL     => { },
     # (date/time tags not as reliable as EXIF)
@@ -672,24 +913,30 @@
     Nickname    => { },
     Rating      => { Writable => 'real', Notes => 'a value from 0 to 5, or -1 for "rejected"' },
-    Thumbnails  => { Struct => \%sThumbnail, List => 'Alt' },
-    ThumbnailsHeight => { Name => 'ThumbnailHeight', Flat => 1 },
-    ThumbnailsWidth  => { Name => 'ThumbnailWidth',  Flat => 1 },
-    ThumbnailsFormat => { Name => 'ThumbnailFormat', Flat => 1 },
-    ThumbnailsImage  => { Name => 'ThumbnailImage',  Flat => 1, Avoid => 1 },
+    RatingPercent=>{ Writable => 'real', Avoid => 1, Notes => 'non-standard' },
+    Thumbnails  => {
+        FlatName => 'Thumbnail',
+        Struct => \%sThumbnail,
+        List => 'Alt',
+    },
     # the following written by Adobe InDesign, not part of XMP spec:
-    PageInfo        => { Struct => \%sPageInfo, List => 'Seq' },
-    PageInfoPageNumber=>{Name => 'PageImagePageNumber', Flat => 1 },
-    PageInfoHeight  => { Name => 'PageImageHeight', Flat => 1 },
-    PageInfoWidth   => { Name => 'PageImageWidth',  Flat => 1 },
-    PageInfoFormat  => { Name => 'PageImageFormat', Flat => 1 },
-    PageInfoImage   => { Name => 'PageImage',       Flat => 1 },
-);
-
-# XMP Rights Management schema properties (xmpRights, xapRights)
+    PageInfo        => {
+        FlatName => 'PageImage',
+        Struct => \%sPageInfo,
+        List => 'Seq',
+    },
+    PageInfoImage => { Name => 'PageImage', Flat => 1 },
+    Title       => { Avoid => 1, Notes => 'non-standard', Writable => 'lang-alt' }, #11
+    Author      => { Avoid => 1, Notes => 'non-standard', Groups => { 2 => 'Author' } }, #11
+    Keywords    => { Avoid => 1, Notes => 'non-standard' }, #11
+    Description => { Avoid => 1, Notes => 'non-standard', Writable => 'lang-alt' }, #11
+    Format      => { Avoid => 1, Notes => 'non-standard' }, #11
+);
+
+# XMP Rights Management namespace properties (xmpRights, xapRights)
 %Image::ExifTool::XMP::xmpRights = (
     %xmpTableDefaults,
     GROUPS => { 1 => 'XMP-xmpRights', 2 => 'Author' },
     NAMESPACE   => 'xmpRights',
-    NOTES => 'XMP Rights Management schema tags.',
+    NOTES => 'XMP Rights Management namespace tags.',
     Certificate     => { },
     Marked          => { Writable => 'boolean' },
@@ -699,17 +946,24 @@
 );
 
-# XMP Note schema properties (xmpNote)
+# XMP Note namespace properties (xmpNote)
 %Image::ExifTool::XMP::xmpNote = (
     %xmpTableDefaults,
     GROUPS => { 1 => 'XMP-xmpNote' },
     NAMESPACE   => 'xmpNote',
-    NOTES => 'XMP Note schema tags.',
-    HasExtendedXMP => { Writable => 'boolean', Protected => 2 },
+    NOTES => 'XMP Note namespace tags.',
+    HasExtendedXMP => {
+        Notes => q{
+            this tag is protected so it is not writable directly.  Instead, it is set
+            automatically to the GUID of the extended XMP when writing extended XMP to a
+            JPEG image
+        },
+        Protected => 2,
+    },
 );
 
 # XMP xmpMM ManifestItem struct (ref PH, written by Adobe PDF library 8.0)
 my %sManifestItem = (
-    NAMESPACE => 'stMfs',
     STRUCT_NAME => 'ManifestItem',
+    NAMESPACE   => 'stMfs',
     linkForm            => { },
     placedXResolution   => { Namespace => 'xmpMM', Writable => 'real' },
@@ -721,14 +975,14 @@
 # the xmpMM Pantry
 my %sPantryItem = (
-    NAMESPACE => undef, # stores any top-level XMP tags
     STRUCT_NAME => 'PantryItem',
+    NAMESPACE   => undef, # stores any top-level XMP tags
     NOTES => q{
         This structure must have an InstanceID field, but may also contain any other
         XMP properties.
     },
-    InstanceID => { Namespace => 'xmpMM' },
-);
-
-# XMP Media Management schema properties (xmpMM, xapMM)
+    InstanceID => { Namespace => 'xmpMM', List => 0 },
+);
+
+# XMP Media Management namespace properties (xmpMM, xapMM)
 %Image::ExifTool::XMP::xmpMM = (
     %xmpTableDefaults,
@@ -736,5 +990,5 @@
     NAMESPACE   => 'xmpMM',
     TABLE_DESC => 'XMP Media Management',
-    NOTES => 'XMP Media Management schema tags.',
+    NOTES => 'XMP Media Management namespace tags.',
     DerivedFrom     => { Struct => \%sResourceRef },
     DocumentID      => { },
@@ -759,7 +1013,8 @@
     RenditionOf     => { Struct => \%sResourceRef }, # (deprecated)
     SaveID          => { Writable => 'integer' }, # (deprecated)
-);
-
-# XMP Basic Job Ticket schema properties (xmpBJ, xapBJ)
+    subject         => { List => 'Seq', Avoid => 1, Notes => 'undocumented' },
+);
+
+# XMP Basic Job Ticket namespace properties (xmpBJ, xapBJ)
 %Image::ExifTool::XMP::xmpBJ = (
     %xmpTableDefaults,
@@ -767,5 +1022,5 @@
     NAMESPACE   => 'xmpBJ',
     TABLE_DESC => 'XMP Basic Job Ticket',
-    NOTES => 'XMP Basic Job Ticket schema tags.',
+    NOTES => 'XMP Basic Job Ticket namespace tags.',
     # Note: JobRef is a List of structures.  To accomplish this, we set the XMP
     # List=>'Bag', but since SubDirectory is defined, this tag isn't writable
@@ -775,5 +1030,5 @@
 );
 
-# XMP Paged-Text schema properties (xmpTPg)
+# XMP Paged-Text namespace properties (xmpTPg)
 %Image::ExifTool::XMP::xmpTPg = (
     %xmpTableDefaults,
